//ConvertirNumerotation_401f.js
// 22.04.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Convertit les numrotations en texte normal

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// quelques variables
var allStories;
var curDoc = app.documents[0];
var curItem;
var curType;
var curStory;

// tester la slection
var selItems = app.selection;
var nItems = selItems.length;

// montrer un dialogue s'il n'y a pas de slection
if (nItems == 0) {
	userDec = confirm("Convertir les numrotations du document entier?");
	if (userDec == true) {
		allStories = curDoc.stories.everyItem();
		allStories.convertBulletsAndNumberingToText();
	}
	else {
		exit();
	}
}
// sinon, une boucle  travers la slection
else {
	for (var i=0; i<nItems; i++) {
		curItem = selItems[i];
		testItems(curItem);
	}
}

alert ("Termin.", "Convertir numrotations");

// la fonction qui teste les objets et convertit 
// les numrotations ventuelles
function testItems(curItem) {
	curType = curItem.constructor.name;
	if (curType == "TextFrame") {
		curStory = curItem.parentStory;
		curStory.convertBulletsAndNumberingToText();
	}
	else if (curType == "InsertionPoint" || curType == "Character" 
		|| curType == "Text" || curType == "Word" || curType == "Line" 
		|| curType == "Paragraph" || curType == "TextStyleRange" 
		|| curType == "TextColumn") {
		curItem.convertBulletsAndNumberingToText();
	}
	else if (curType == "Group") {
		testGroups(curItem);
	}
}

// la fonction qui traite les groupes (sans dgrouper)
function testGroups(curGroup) {
	var allFrames = curGroup.allPageItems;
	for (var i=0; i< allFrames.length; i++) {
		var curFrame = allFrames[i];
		var curType = curFrame.constructor.name;
		if (curType == "Group") {
			testGroups(curFrame);
		}
		else if (curType == "TextFrame") {
			curStory = curFrame.parentStory;
			curStory.convertBulletsAndNumberingToText();
		}
	}
}